"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var react_native_1 = require("react-native");
var image_editor_1 = __importDefault(require("@react-native-community/image-editor"));
var react_native_image_size_1 = __importDefault(require("react-native-image-size"));
var react_native_image_resizer_1 = __importDefault(require("react-native-image-resizer"));
// @ts-ignore
var react_native_image_rotate_1 = __importDefault(require("react-native-image-rotate"));
var ImageViewer_1 = __importDefault(require("./ImageViewer"));
var percentCalculator_1 = require("./helpers/percentCalculator");
var window = react_native_1.Dimensions.get('window');
var w = window.width;
var defaultProps = {
    cropAreaWidth: w,
    cropAreaHeight: w,
    containerColor: 'black',
    areaColor: 'black',
};
var ImageCropper = /** @class */ (function (_super) {
    __extends(ImageCropper, _super);
    function ImageCropper() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            positionX: 0,
            positionY: 0,
            width: 0,
            height: 0,
            scale: 1,
            minScale: 1,
            loading: true,
            srcSize: {
                width: 0,
                height: 0,
            },
            fittedSize: {
                width: 0,
                height: 0,
            },
            prevImageUri: '',
            isVerticalImageForAndroidOnly: false,
            rotationForAndroidOnly: 0,
        };
        _this.init = function () { return __awaiter(_this, void 0, void 0, function () {
            var _a, imageUri, setCropperParams, cropAreaWidth, cropAreaHeight;
            var _this = this;
            return __generator(this, function (_b) {
                _a = this.props, imageUri = _a.imageUri, setCropperParams = _a.setCropperParams, cropAreaWidth = _a.cropAreaWidth, cropAreaHeight = _a.cropAreaHeight;
                react_native_1.Image.getSize(imageUri, function (widthSize, heightSize) { return __awaiter(_this, void 0, void 0, function () {
                    var width, height, isVerticalImageForAndroidOnly, rotationForAndroidOnly, realSize, areaWidth, areaHeight, srcSize, fittedSize, scale, ratio, ratio;
                    var _this = this;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                width = 0;
                                height = 0;
                                isVerticalImageForAndroidOnly = false;
                                rotationForAndroidOnly = 0;
                                if (!(react_native_1.Platform.OS === 'ios')) return [3 /*break*/, 1];
                                width = widthSize;
                                height = heightSize;
                                return [3 /*break*/, 3];
                            case 1: return [4 /*yield*/, react_native_image_size_1.default.getSize(imageUri)];
                            case 2:
                                realSize = _a.sent();
                                rotationForAndroidOnly = realSize.rotation;
                                isVerticalImageForAndroidOnly =
                                    widthSize < heightSize && realSize.width > realSize.height;
                                width = isVerticalImageForAndroidOnly
                                    ? realSize.height
                                    : realSize.width;
                                height = isVerticalImageForAndroidOnly
                                    ? realSize.width
                                    : realSize.height;
                                _a.label = 3;
                            case 3:
                                areaWidth = cropAreaWidth;
                                areaHeight = cropAreaHeight;
                                srcSize = { width: width, height: height };
                                fittedSize = { width: 0, height: 0 };
                                scale = 1;
                                if (width > height) {
                                    ratio = w / height;
                                    fittedSize.width = width * ratio;
                                    fittedSize.height = w;
                                }
                                else if (width < height) {
                                    ratio = w / width;
                                    fittedSize.width = w;
                                    fittedSize.height = height * ratio;
                                }
                                else if (width === height) {
                                    fittedSize.width = w;
                                    fittedSize.height = w;
                                }
                                if (areaWidth < areaHeight || areaWidth === areaHeight) {
                                    if (width < height) {
                                        if (fittedSize.height < areaHeight) {
                                            scale = Math.ceil((areaHeight / fittedSize.height) * 10) / 10;
                                        }
                                        else {
                                            scale = Math.ceil((areaWidth / fittedSize.width) * 10) / 10;
                                        }
                                    }
                                    else {
                                        scale = Math.ceil((areaHeight / fittedSize.height) * 10) / 10;
                                    }
                                }
                                scale = scale < 1 ? 1 : scale;
                                this.setState(function (prevState) { return (__assign(__assign({}, prevState), { srcSize: srcSize,
                                    fittedSize: fittedSize, minScale: scale, loading: false, isVerticalImageForAndroidOnly: isVerticalImageForAndroidOnly,
                                    rotationForAndroidOnly: rotationForAndroidOnly })); }, function () {
                                    var _a = _this.state, positionX = _a.positionX, positionY = _a.positionY;
                                    setCropperParams({
                                        positionX: positionX,
                                        positionY: positionY,
                                        scale: scale,
                                        srcSize: srcSize,
                                        fittedSize: fittedSize,
                                        isVerticalImageForAndroidOnly: isVerticalImageForAndroidOnly,
                                        rotationForAndroidOnly: rotationForAndroidOnly,
                                    });
                                });
                                return [2 /*return*/];
                        }
                    });
                }); }, function () { });
                return [2 /*return*/];
            });
        }); };
        _this.handleMove = function (_a) {
            var positionX = _a.positionX, positionY = _a.positionY, scale = _a.scale;
            var setCropperParams = _this.props.setCropperParams;
            _this.setState(function (prevState) { return (__assign(__assign({}, prevState), { positionX: positionX,
                positionY: positionY,
                scale: scale })); }, function () {
                var _a = _this.state, srcSize = _a.srcSize, fittedSize = _a.fittedSize, isVerticalImageForAndroidOnly = _a.isVerticalImageForAndroidOnly, rotationForAndroidOnly = _a.rotationForAndroidOnly;
                setCropperParams({
                    positionX: positionX,
                    positionY: positionY,
                    scale: scale,
                    srcSize: srcSize,
                    fittedSize: fittedSize,
                    isVerticalImageForAndroidOnly: isVerticalImageForAndroidOnly,
                    rotationForAndroidOnly: rotationForAndroidOnly,
                });
            });
        };
        return _this;
    }
    ImageCropper.getDerivedStateFromProps = function (props, state) {
        if (props.imageUri !== state.prevImageUri) {
            return {
                prevImageUri: props.imageUri,
                loading: true,
            };
        }
        return null;
    };
    ImageCropper.prototype.componentDidMount = function () {
        this.init();
    };
    ImageCropper.prototype.componentDidUpdate = function (prevProps) {
        var imageUri = this.props.imageUri;
        if (imageUri && prevProps.imageUri !== imageUri) {
            this.init();
        }
    };
    ImageCropper.prototype.render = function () {
        var _a = this.state, loading = _a.loading, fittedSize = _a.fittedSize, minScale = _a.minScale;
        var _b = this.props, imageUri = _b.imageUri, cropAreaWidth = _b.cropAreaWidth, cropAreaHeight = _b.cropAreaHeight, containerColor = _b.containerColor, areaColor = _b.areaColor;
        var areaWidth = cropAreaWidth;
        var areaHeight = cropAreaHeight;
        var imageWidth = fittedSize.width;
        var imageHeight = fittedSize.height;
        return !loading ? (react_1.default.createElement(ImageViewer_1.default, { image: imageUri, areaWidth: areaWidth, areaHeight: areaHeight, imageWidth: imageWidth, imageHeight: imageHeight, minScale: minScale, onMove: this.handleMove, containerColor: containerColor, imageBackdropColor: areaColor })) : null;
    };
    ImageCropper.crop = function (params) {
        var positionX = params.positionX, positionY = params.positionY, scale = params.scale, srcSize = params.srcSize, fittedSize = params.fittedSize, cropSize = params.cropSize, cropAreaSize = params.cropAreaSize, imageUri = params.imageUri, isVerticalImageForAndroidOnly = params.isVerticalImageForAndroidOnly, rotationForAndroidOnly = params.rotationForAndroidOnly;
        var offset = {
            x: 0,
            y: 0,
        };
        var cropAreaW = cropAreaSize ? cropAreaSize.width : w;
        var cropAreaH = cropAreaSize ? cropAreaSize.height : w;
        var wScale = cropAreaW / scale;
        var hScale = cropAreaH / scale;
        var percentCropperAreaW = percentCalculator_1.getPercentDiffNumberFromNumber(wScale, fittedSize.width);
        var percentRestW = 100 - percentCropperAreaW;
        var hiddenAreaW = percentCalculator_1.getPercentFromNumber(percentRestW, fittedSize.width);
        var percentCropperAreaH = percentCalculator_1.getPercentDiffNumberFromNumber(hScale, fittedSize.height);
        var percentRestH = 100 - percentCropperAreaH;
        var hiddenAreaH = percentCalculator_1.getPercentFromNumber(percentRestH, fittedSize.height);
        var x = hiddenAreaW / 2 - positionX;
        var y = hiddenAreaH / 2 - positionY;
        offset.x = x <= 0 ? 0 : x;
        offset.y = y <= 0 ? 0 : y;
        var srcPercentCropperAreaW = percentCalculator_1.getPercentDiffNumberFromNumber(offset.x, fittedSize.width);
        var srcPercentCropperAreaH = percentCalculator_1.getPercentDiffNumberFromNumber(offset.y, fittedSize.height);
        var offsetW = percentCalculator_1.getPercentFromNumber(srcPercentCropperAreaW, srcSize.width);
        var offsetH = percentCalculator_1.getPercentFromNumber(srcPercentCropperAreaH, srcSize.height);
        var sizeW = percentCalculator_1.getPercentFromNumber(percentCropperAreaW, srcSize.width);
        var sizeH = percentCalculator_1.getPercentFromNumber(percentCropperAreaH, srcSize.height);
        offset.x = Math.floor(offsetW);
        offset.y = Math.floor(offsetH);
        var cropData = {
            offset: offset,
            size: {
                width: Math.floor(sizeW),
                height: Math.floor(sizeH),
            },
            displaySize: {
                width: Math.round(cropSize.width),
                height: Math.round(cropSize.height),
            },
        };
        if (react_native_1.Platform.OS === 'ios') {
            return new Promise(function (resolve, reject) {
                return image_editor_1.default.cropImage(imageUri, cropData)
                    .then(resolve)
                    .catch(reject);
            });
        }
        if (rotationForAndroidOnly === 0) {
            return new Promise(function (resolve, reject) {
                return react_native_image_rotate_1.default.rotateImage(imageUri, isVerticalImageForAndroidOnly ? 90 : 0, function (urlRotatedImage) {
                    return react_native_image_resizer_1.default.createResizedImage(urlRotatedImage, srcSize.width, srcSize.height, 'JPEG', 100, 360)
                        .then(function (res) { return __awaiter(void 0, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            return [2 /*return*/, image_editor_1.default.cropImage(res.uri, cropData)
                                    .then(resolve)
                                    .catch(reject)];
                        });
                    }); })
                        .catch(reject);
                }, function (error) {
                    return reject(error);
                });
            });
        }
        // INFO: RC
        return new Promise(function (resolve, reject) {
            return react_native_image_resizer_1.default.createResizedImage(imageUri, srcSize.width, srcSize.height, 'JPEG', 100, 360)
                .then(function (_a) {
                var uri = _a.uri;
                return __awaiter(void 0, void 0, void 0, function () {
                    return __generator(this, function (_b) {
                        return [2 /*return*/, image_editor_1.default.cropImage(uri, cropData)
                                .then(resolve)
                                .catch(reject)];
                    });
                });
            })
                .catch(reject);
        });
    };
    ImageCropper.defaultProps = defaultProps;
    return ImageCropper;
}(react_1.PureComponent));
exports.default = ImageCropper;
